/******************************************************************************
 *	gisubwin.c:	TuEBhȄ֐
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 */
#include <stdio.h>		/* sprintf()Ȃ			*/
#include <event.h>		/* Cxg}𗘗pƂɕKv	*/
#include <sxgraph.h>		/* Otn}l[W𗘗pƂɕKv */
#include <window.h>		/* EBhE}𗘗pƂɕKv	*/
#include <control.h>		/* Rg[}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "gimage.h"		/* ̃vOŗL̃wb_t@C	*/

static Rect wsSize[SUBMAX] = {		/* TuEBhETCY		*/
	{ 0, 0, TLSUB_H, TLSUB_V },	/* c[EBhE		*/
	{ 0, 0, PLSUB_H, PLSUB_V }	/* FIEBhE		*/
};

/******************************************************************************
 *	createSubwin():	TuEBhE̍쐬
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬siIj
 */
BOOLEAN createSubwin(ComVal *pcv)
{
	int i;
	Rect rc;

	static Point wsPos[SUBMAX] = {	/* TuEBhE̕\ʒu	*/
		{ TLPOS_X, TLPOS_Y },	/* c[EBhE		*/
		{ PLPOS_X, PLPOS_Y }	/* FIEBhE		*/
	};

	for (i = 0; i < SUBMAX; i++) {
		/* [Wnhmۂ */
		pcv->subRgnHdl[i] = GMNewRgn();
		if (pcv->subRgnHdl[i] == NULL)
			return FALSE;	/* ŝFALSEԂ	*/

		/* TuEBhE̊Ogi[Wjݒ肷 */
		rc = wsSize[i];
		rc.d.right--;
		rc.d.bottom--;
		GMRectRgn(pcv->subRgnHdl[i], &rc);
		rc.d.left += 4;
		rc.d.top += 4;
		rc.d.right++;
		rc.d.bottom++;
		GMOrRectRgn(pcv->subRgnHdl[i], pcv->subRgnHdl[i], &rc);
		rc = wsSize[i];
		GMSlideRect(&rc, wsPos[i].x_y);
		TSAdjustRect(&rc, &rc, 16); /* \ʒu␳	*/
		GMSlideRgn(pcv->subRgnHdl[i], rc.l.l_t);

		/* TuEBhEI[vłH */
		if (!openSubwin(pcv, i))
			return FALSE;	/* ŝFALSEԂ	*/
	}
	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	openSubwin():	TuEBhẼI[v
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍ
 *	߂l:	BOOLEAN		= TRUE:  I[v
 *				= FALSE: I[vs
 */
BOOLEAN openSubwin(ComVal *pcv, int num)
{
	pcv->subwinPtr[num] = WSOpen(	/* TuEBhEI[v	*/
		NULL,			/* TuEBhE|C^mۂ */
		pcv->subRgnHdl[num],	/* [Wnh		*/
		(unsigned long) num + 32); /* vCIeBliʏ32ȏj*/
	if (pcv->subwinPtr[num] == NULL)
		return FALSE;		/* ŝFALSEԂ	*/

	if (num == TOOL)		/* c[EBhEH		*/
		if (!createSubControl(pcv)) /* Rg[쐬	*/
			return FALSE;	/* ŝFALSEԂ	*/

	/* TuEBhEJgOtɂ */
	GMSetGraph(&pcv->subwinPtr[num]->win.graph);
	GMPenMode(G_PSET);		/* y[hPSETɂ	*/
	GMForeColor(G_BLACK);		/* tHAOEhJ[ɂ */
	/* obNOEhJ[CgO[ɂ */
	GMBackColor(G_LGRAY);
	GMFontMode(G_PSET);		/* tHg[hPSETɂ	*/
	/* ^XNhc̏ʃ[hɃTuEBhE̒ʂԍ(OȊO) */
	pcv->subwinPtr[num]->win.taskID = LONGWORD(num + 1, TSGetID());
	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	closeSubwin():	TuEBhẼN[Y
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍ
 */
void closeSubwin(ComVal *pcv, int num)
{
	if (num == TOOL)		/* c[EBhEH		*/
		/* Rg[p */
		CMKill(&pcv->subwinPtr[TOOL]->win);
	WSDispose(pcv->subwinPtr[num]);	/* TuEBhEN[Y	*/
}

/******************************************************************************
 *	createSubControl():	TuEBhẼRg[̍쐬
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬siIj
 */
BOOLEAN createSubControl(ComVal *pcv)
{
	int penX = pcv->penSize.p.x;

	static Rect bounds = {		/* l{^̈ʒuƑ傫	*/
		ADJ_X, ADJ_Y, ADJ_X + ADJBTN_H + 6 * 3 + 8, ADJ_Y + ADJBTN_V
	};

	/* l{^̃^Cg쐬 */
	sprintf((char *) pcv->adjBtnTtl, "\x03%3d", penX);
	/* l{^쐬 */
	pcv->adjBtnHdl = CMOpen(&pcv->subwinPtr[TOOL]->win, &bounds,
		pcv->adjBtnTtl, TRUE, penX, 1, 50, CI_ADJBTN << 4, 0);
	if (pcv->adjBtnHdl == NULL)
		return FALSE;		/* ŝFALSEԂ	*/

	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	checkSubControl():	TuEBhẼRg[̃`FbN
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void checkSubControl(ComVal *pcv)
{
	int partCode;			/* Rg[̃p[gR[h	*/
	Control **ctrlHdl;		/* Rg[nh		*/

	/* }EX̃{^ĂԁARg[̊e폈VXe
	   CāARg[nhƃ{^ꂽA܂͗ꂽꏊ
	   ̃p[gR[h擾 */
	partCode = SXCallCtrlM(&pcv->subwinPtr[TOOL]->win, &pcv->event, 0, 0, NULL, &ctrlHdl);
	/* l{^ŁAnhvH */
	if ((partCode == C_INDEC || partCode == C_ININC)
	 && ctrlHdl == pcv->adjBtnHdl) {
		/* l{^̃s[gs */
		repeatAdjBtn(pcv, partCode);
		/* y[Nɐݒ肷 */
		pcv->penSize.p.x = CMValueGet(pcv->adjBtnHdl);
		pcv->penSize.p.y = pcv->penSize.p.x;
	}
}

/******************************************************************************
 *	msLDownSubwin(): TuEBhẼ}EXtg_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍ
 *	߂l:	int		TuEBhẼp[gR[h
 *	:
 *	TuEBhEŃ}EX̍{^ꂽꍇ̏sBT|[g
 *	鏈́ATuEBhËړAN[Y{^̋\ŁA}EX
 *	̃{^ꂽA܂͗ꂽꏊ̃p[gR[h擾܂B
 */
int msLDownSubwin(ComVal *pcv, int num)
{
	LPoint lpt;
	Rect rc;

	static Rect wsInside[SUBMAX] = { /* TuEBhE̓	*/
		/* c[EBhE */
		{ WS_INSIDE_X, WS_INSIDE_Y, TLSUB_H - 2, TLSUB_V - 2 },
		/* FIEBhE */
		{ WS_INSIDE_X, WS_INSIDE_Y, PLSUB_H - 2, PLSUB_V - 2 }
	};

	calcPctBtn(num, CLOSE, &rc);	/* N[Y{^̈ʒu߂	*/
	/* Cxg̃|C^W[JWnɕϊ */
	lpt = GMGlobalToLocal(pcv->event.ev.where.x_y);
	if (GMPtInRect(&rc, lpt)) {	/* N[Y{^ꂽH	*/
		if (checkPctBtn(pcv, num, CLOSE, lpt)) {
			/* TuEBhE */
			WSDelist(pcv->subwinPtr[num]);
			pcv->subActiveFlag[num] = FALSE;
			return WS_INCLOSE;
		}
	/* TuEBhE̓H */
	} else if (GMPtInRect(&wsInside[num], lpt)) {
		return WS_ININSIDE;

	/* TuEBhẼhbO[WiłȂj*/
	} else {
		dragSubwin(pcv, lpt, num); /* TuEBhEhbO */
		return WS_INDRAG;
	}

	return 0;
}

/******************************************************************************
 *	dragSubwin():	TuEBhẼhbOiړj
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		LPoint lpt	|C^W([JWnj
 *		int num		TuEBhE̔ԍ
 */
void dragSubwin(ComVal *pcv, LPoint lpt, int num)
{
	Point pt, pt2, npt, dpt;
	Rect rc;

	rc = wsSize[num];
	GMInvertRect(&rc, WS_RUBBERBAND); /* o[oh`悷	*/
	pt.x_y = lpt;
	/* TuEBhE̍W}EX݈̌ʒu܂ł̋vZ */
	pt2.p.x = pcv->event.ev.where.p.x - (*pcv->subRgnHdl[num])->bounds.d.left;
	pt2.p.y = pcv->event.ev.where.p.y - (*pcv->subRgnHdl[num])->bounds.d.top;
	/* }EX̍{^ꂽ܂܂ȂAo[ohړ */
	do {
		npt.x_y = EMMSLoc();	/* }EX݈̌ʒu擾	*/
		if (npt.x_y != pt.x_y) { /* }EXړH	*/
			/* o[oh */
			GMInvertRect(&rc, WS_RUBBERBAND);
			/* ړ̃N^Oݒ肷 */
			dpt.p.x = npt.p.x - pt.p.x;
			dpt.p.y = npt.p.y - pt.p.y;
			GMSlideRect(&rc, dpt.x_y);
			/* o[oh`悷 */
			GMInvertRect(&rc, WS_RUBBERBAND);
		}
		pt = npt;
	} while (EMLStill());		/* {^ꂽI	*/
	GMInvertRect(&rc, WS_RUBBERBAND); /* o[oh	*/

	/* {^ꂽʒuhbOJnʒuƓH */
	if (pt.x_y == lpt)
		return;			/* ꍇ͂̂܂		*/

	/* ړ̃TuEBhE̊Ogi[Wjݒ肷 */
	pt.p.x -= pt2.p.x;
	pt.p.y -= pt2.p.y;
	GMSlideRgn(pcv->subRgnHdl[num], pt.x_y);

	/* TuEBhËړ́ATuEBhExN[Y
	   V[WōēxI[v */
	closeSubwin(pcv, num);		/* TuEBhEN[Y	*/
	if (!openSubwin(pcv, num)) {	/* TuEBhEI[v	*/
		/* TuEBhEI[vłȂ̂ŁAhbO͎s */
		pcv->subActiveFlag[num] = FALSE;
		pcv->errorCode = 5;
		pcv->endFlag = TRUE;	/* ItOZbg	*/
	}
}

/******************************************************************************
 *	drawSubwin():	TuEBhE̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍ
 */
void drawSubwin(ComVal *pcv, int num)
{
	int i, lastAP, lastPM;
	Rect rc;

	/* TuEBhEeLXg^CvŃJgOtɂ */
	setGraph(pcv, num, G_TXT);

	rc = wsSize[num];
	/* TuEBhE`悷ꍇ́A܂ŚiSy[WjNA */
	lastAP = GMAPage(G_ALLPAGE);	/* ANZXy[WSy[Wɂ */
	/* y[hobNOEhJ[ɂ */
	lastPM = GMPenMode(G_BACK << 8 | G_PSET);
	GMFillRect(&rc);		/* TuEBhENA	*/
	GMPenMode(lastPM);		/* y[hɖ߂		*/
	GMAPage(lastAP);		/* ANZXy[Wɖ߂	*/

	GMFrameRect(&rc);		/* TuEBhE̊Og`悷 */
	rc.d.right--;
	rc.d.bottom--;
	GMFrameRect(&rc);
	drawSubTitleBar(pcv, num);	/* ^Cgo[`悷	*/

	switch (num) {
	case TOOL:			/* c[EBhE		*/
		/* ANZXy[WO`Qy[Wɂ */
		GMAPage(G_PAGE0 | G_PAGE1 | G_PAGE2);
		/* "y"`悷 */
		GMShadowStrZ("y", LONGWORD(10, WS_INSIDE_Y + 6));
		for (i = 0; i < 12; i++) {
			/* sN`[{^̈ʒu߂ */
			calcPctBtn(TOOL, i, &rc);
			/* sN`[{^`悷 */
			GMPutRImg(*pcv->pctBtnImg[i], rc.l.l_t);
			if (i == pcv->toolKind) /* IĂc[H */
				revFrameRect(&rc); /* t[𔽓] */
		}
		GMAPage(lastAP);	/* ANZXy[Wɖ߂	*/
		CMDraw(&pcv->subwinPtr[TOOL]->win); /* Rg[`悷 */
		break;
	case PALET:			/* FIEBhE		*/
		for (i = 0; i < 16; i++) {
			/* sN`[{^̈ʒu߂ */
			calcPctBtn(PALET, i, &rc);
			/* PAT4̃f[^Ȃ̂ŁAANZXy[WSy[Wɂ */
			GMAPage(G_ALLPAGE);
			/* sN`[{^`悷 */
			GMPutRImg(*pcv->plBtnImg, rc.l.l_t);
			GMAPage(lastAP); /* ANZXy[Wɖ߂	*/
			if (i == pcv->paletNo) /* IĂpbgH */
				revFrameRect(&rc); /* t[𔽓] */

			/* FIEBhEOtBbN^CvŃJg
			   Otɂ */
			setGraph(pcv, PALET, G_GRP);
			/* OtBbNXN[pbgԍœhԂ */
			GMForeColor(i);
			/* J[̃N^O߂ */
			GMInsetRect(&rc, LONGWORD(2, 2));
			GMFillRect(&rc);

			/* FIEBhEeLXg^CvŃJgOt
			    */
			setGraph(pcv, PALET, G_TXT);
			/* tHAOEhJ[ɖ߂ */
			GMForeColor(G_BLACK);
		}
		break;
	}
}

/******************************************************************************
 *	drawSubTitleBar():	TuEBhẼ^Cg̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍ
 */
void drawSubTitleBar(ComVal *pcv, int num)
{
	int i;
	Rect rc;

	/* TuEBhẼ^Cgo[̕` */
	struct {
		int color;
		Rect rc;
	} wsTitle[7] = {
		{ G_DGRAY, {  1,  1, -2, 17 }},
		{ G_WHITE, {  1,  1,  3, 16 }},
		{ G_WHITE, {  3,  1, -2,  3 }},
		{ G_DGRAY, {  2, 15, -2, 18 }},
		{ G_BLACK, { -3,  2, -1, 17 }},
		{ G_BLACK, {  1, 16, -3, 17 }},
		{ G_BLACK, {  3, 15, -3, 16 }}
	};

	/* TuEBhẼ^Cgo[`悷 */
	for (i = 0; i < 7; i++) {
		GMForeColor(wsTitle[i].color);
		if (wsTitle[i].rc.d.left < 0)
			wsTitle[i].rc.d.left += wsSize[num].d.right;
		if (wsTitle[i].rc.d.right < 0)
			wsTitle[i].rc.d.right += wsSize[num].d.right;
		GMFillRect(&wsTitle[i].rc);
	}
	GMForeColor(G_BLACK);		/* tHAOEhJ[ɖ߂ */

	calcPctBtn(num, CLOSE, &rc);	/* N[Y{^̈ʒu߂	*/
	GMPutRImg(*pcv->pctBtnImg[12], rc.l.l_t); /* N[Y{^`悷 */
}

/******************************************************************************
 *	selectPctBtn():	sN`[{^̑I
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍ
 *	߂l:	int		sN`[{^̔ԍiP`PTj
 *				< 0: IȂ
 */
void selectPctBtn(ComVal *pcv, int num)
{
	int i, cnt, ono;
	LPoint lpt;
	Rect rc;

	if (num == TOOL) {		/* c[EBhEH		*/
		ono = pcv->toolKind;
		cnt = 12;
	} else {			/* FIEBhE		*/
		ono = pcv->paletNo;
		cnt = 16;
	}
	/* ͍W[JWnɕϊ */
	lpt = GMGlobalToLocal(pcv->event.ev.where.x_y);
	/* ꂽǂׂ̕ */
	for (i = 0; i < cnt; i++) {
		calcPctBtn(num, i, &rc); /* sN`[{^̈ʒu߂ */
		if (GMPtInRect(&rc, lpt)) {
			/* OƈႤsN`[{^IꂽH */
			if (i != ono && checkPctBtn(pcv, num, i, lpt)) {
				if (num == TOOL) /* c[EBhEH */
					/* c[ύX */
					pcv->toolKind = i;
				else	/* FIEBhE		*/
					/* pbgύX */
					pcv->paletNo = i;
			}
			return;
		}
	}
}

/******************************************************************************
 *	calcPctBtn():	sN`[{^̈ʒuZo
 ******************************************************************************
 *	:	int num		TuEBhE̔ԍ
 *		int no		sN`[{^̔ԍiO`PTACLOSEj
 *		Rect *prc	\ʒũN^Oi[|C^
 */
void calcPctBtn(int num, int no, Rect *prc)
{
	Point pt;

	/* N[Y{^̃TCY */
	static Rect clsSize = { 0, 0, WS_CLOSE_W, WS_CLOSE_W };
	/* ̑̃sN`[{^̃TCY */
	static Rect pctSize = { 0, 0, 20, 20 };

	if (no == CLOSE) {		/* N[Y{^H		*/
		*prc = clsSize;
		pt.x_y = LONGWORD(wsSize[num].d.right - WS_CLOSE_W - 4, 4);
	} else {			/* ̑̃sN`[{^	*/
		*prc = pctSize;
		switch (num) {
		case TOOL:		/* c[EBhE		*/
			pt.p.x = 10;
			pt.p.y = WS_INSIDE_Y + 24;
			if (no >= 6) {
				no -= 6;
				pt.p.y += 21;
			}
			break;
		case PALET:		/* FIEBhE		*/
			pt.p.x = 4;
			pt.p.y = WS_INSIDE_Y + 2;
			if (no >= 8) {
				no -= 8;
				pt.p.y += 21;
			}
			break;
		}
		pt.p.x += no * 20;
	}
	GMSlideRect(prc, pt.x_y);
}

/******************************************************************************
 *	checkPctBtn():	sN`[{^̃`FbN
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍ
 *		int no		sN`[{^̔ԍiO`PTACLOSEj
 *		LPoint lpt	|C^W([JWnj
 *	߂l:	BOOLEAN overFlag = TRUE:  sN`[{^̏ŗꂽ
 *				 = FALSE: sN`[{^̊Oŗꂽ
 */
BOOLEAN checkPctBtn(ComVal *pcv, int num, int no, LPoint lpt)
{
	BOOLEAN now, overFlag = TRUE;
	Rect rc;

	calcPctBtn(num, no, &rc);	/* sN`[{^̈ʒu߂ */
	if (no == CLOSE)		/* N[Y{^H		*/
		revFillRect(&rc);	/* N[Y{^𔽓]	*/
	else				/* ̑̃sN`[{^	*/
		changePctBtn(pcv, num, no); /* sN`[{^ύX */
	/* }EX̍{^܂Ń[v */
	do {
		now = GMPtInRect(&rc, EMMSLoc());
		if (now != overFlag) {
			/* }EẌʒusN`[{^ォωA
			   sN`[{^𔽓]^ύX */
			if (no == CLOSE) /* N[Y{^H		*/
				revFillRect(&rc);
			else		/* ̑̃sN`[{^	*/
				changePctBtn(pcv, num, no);
			overFlag = now;
		}
	} while (EMLStill());		/* {^ꂽI	*/

	return overFlag;
}

/******************************************************************************
 *	changePctBtn():	ݑI𒆂̃sN`[{^̕ύX
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int num		TuEBhE̔ԍ
 *		int no		IꂽsN`[{^̔ԍiO`PTj
 */
void changePctBtn(ComVal *pcv, int num, int no)
{
	Rect rc;

	/* OIĂsN`[{^̈ʒu߂ */
	calcPctBtn(num, ((num == TOOL) ? pcv->toolKind : pcv->paletNo), &rc);
	revFrameRect(&rc);	/* sN`[{^ɖ߂	*/
	/* IꂽsN`[{^̈ʒu߂ */
	calcPctBtn(num, no, &rc);
	revFrameRect(&rc);	/* sN`[{^𔽓]	*/
}

/******************************************************************************
 *	revFillRect():	N^ȎSʔ]
 ******************************************************************************
 *	:	Rect *prc	]郌N^Oւ̃|C^
 */
void revFillRect(Rect *prc)
{
	int lastPM;

	lastPM = GMPenMode(G_XOR);	/* y[hXORɂ	*/
	GMFillRect(prc);
	GMPenMode(lastPM);		/* y[hɖ߂		*/
}

/******************************************************************************
 *	revFrameRect():	N^Õt[]
 ******************************************************************************
 *	:	Rect *prc	]郌N^Oւ̃|C^
 */
void revFrameRect(Rect *prc)
{
	int lastPM;

	lastPM = GMPenMode(G_XOR);	/* y[hXORɂ	*/
	GMFrameRect(prc);
	GMPenMode(lastPM);		/* y[hɖ߂		*/
}
